author = "Marc Ruef"
license = "(c) 2010 by scip AG"
version = "1.0-hd10"
categories = {"default", "safe", "scip"}

require("scipreporting_hashdays")
require("shortport")

description = [[]]

portrule = shortport.port_or_service({80, 81, 8080, 443, 8443}, {"http", "https"}, {"tcp"})

action = function(host, port)
	local socket = nmap.new_socket()
	local result
	local status = true
	local serverline
	local EtagFound = false

	local err_catch = function()
		socket:close()
	end

	local try = nmap.new_try(err_catch)

	socket:set_timeout(5000)
	try(socket:connect(host.ip, port.number, port.protocol))
	try(socket:send("GET / HTTP/1.0\n\n"))
        while status do
		status, result = socket:receive_lines(10);
		serverline = string.match(result, "(ETag:(.-))[\r\n]")
		if serverline ~= nil and serverline ~= "" then
			sOutput = serverline
			EtagFound = true
			break
		end
	end
	socket:close()

	if EtagFound == true then
		sAccuracy	= SCIP_DEFAULT_SCANNING_ACCURACY
		sTesttype	= "Scanning"
		sTestsource	= "HTTP-Banner (ETag Line)"
		sDescription	= "The web server is using the Etag within the http headers of the responses. An attacker might use these to increase the accuracy of http fingerprinting to identify the server implementation."

		return scipreport(8, sAccuracy, sTesttype, sTestsource, version, sOutput, sDescription)
	end
end
