author = "Marc Ruef"
license = "(c) 2010 by scip AG"
version = "1.0-hd10"
categories = {"default", "safe", "scip"}

require("scipreporting_hashdays")
require("shortport")

description = [[]]

portrule = shortport.port_or_service({80, 81, 8080, 443, 8443}, {"http", "https"}, {"tcp"})

action = function(host, port)
	local socket = nmap.new_socket()
	local result
	local status = true
	local PipeliningPossible = false

	local err_catch = function()
		socket:close()
	end

	local try = nmap.new_try(err_catch)

	socket:set_timeout(5000)
	try(socket:connect(host.ip, port.number, port.protocol))
	try(socket:send("GET / HTTP/1.0\n\n"))
        while status do
		status, result = socket:receive_lines(1);
		if string.match(result, "^HTTP/1.1") then
			PipeliningPossible = true
			break
		end
	end
	socket:close()

	if PipeliningPossible == true then
		sAccuracy	= SCIP_DEFAULT_APPFINGERPRINT_ACCURACY
		sTesttype	= "Scanning"
		sTestsource	= "HTTP/1.1 in Response"
		sOutput		= "The web server has been switching to HTTP/1.1 which indicates the support for HTTP/1.1 pipelining. This information might be used for fingerprinting of the service and target-oriented attacks."

		return scipreport(10, sAccuracy, sTesttype, sTestsource, version, sDescription)
	end
end
