author = "Marc Ruef"
license = "(c) 2010 by scip AG"
version = "1.0-hd10"
categories = {"default", "safe", "scip"}

require("scipreporting_hashdays")
require("shortport")
require("http")

description = [[ This script is identifying web servers which are supporting NTLM authentication ]]

portrule = shortport.port_or_service({80, 81, 8080, 443, 8443}, {"http", "https"}, {"tcp"})

action = function(host, port)
	local response = http.get(host, port, "/")
	if response.rawheader ~= nil then
		local rawheader = stdnse.format_output(true, response.rawheader)
		local stringfound = string.match(rawheader, "WWW-Authenticate: NTLM")

		if stringfound ~= nil and stringfound ~= "" then
			sAccuracy	= SCIP_DEFAULT_SCANNING_ACCURACY
			sTesttype	= "Scanning"
			sTestsource	= "HTTP Header Enumeration"
			sOutput		= rawheader
			sDescription	= "The web server is supporting an NTLM authentication. This may indicate a Microsoft IIS web server which might be approached in a target-oriented attack."
	
			return scipreport(14, sAccuracy, sTesttype, sTestsource, version, sOutput, sDescription)
		end
	end
end
