author = "Marc Ruef"
license = "(c) 2010 by scip AG"
version = "1.0-hd10"
categories = {"default", "safe", "scip"}

require("scipreporting_hashdays")
require("shortport")
require("http")

description = [[ This script is identifying web servers which provide a X-Powered-By line ]]

portrule = shortport.port_or_service({80, 81, 8080, 443, 8443}, {"http", "https"}, {"tcp"})

action = function(host, port)
	local response = http.get(host, port, "/")
	if response.rawheader ~= nil then
		local rawheader = stdnse.format_output(true, response.rawheader)
		local stringfound = string.match(rawheader, "X-Powered-By: (.-)[\r\n]")

		if stringfound ~= nil and stringfound ~= "" then
			sAccuracy	= SCIP_DEFAULT_SCANNING_ACCURACY
			sTesttype	= "Scanning"
			sTestsource	= "HTTP-Banner (X-Powered-By Line)"
			sOutput		= stringfound
			sDescription	= "The web server is announcing addition software components in the X-Powered-By line of the http header. An attacker might use this information to initiiate target-oriented attacks."
	
			return scipreport(6, sAccuracy, sTesttype, sTestsource, version, sOutput, sDescription)
		end
	end
end
