--- scip Output Wrapper for Hashdays Demo
-- @author Marc Ruef
-- Version: 1.0-hd10

-- Default Values
SCIP_DEFAULT_DERIVATIVE_ACCURACY = 70
SCIP_DEFAULT_PORTSCAN_ACCURACY = 70
SCIP_DEFAULT_SCANNING_ACCURACY = 80
SCIP_DEFAULT_APPMAPPING_ACCURACY = 80
SCIP_DEFAULT_APPFINGERPRINT_ACCURACY = 90
SCIP_DEFAULT_EXPLOITING_ACCURACY = 99

function scipreport_HD(sID, sAccuracy, sTesttype, sTestsource, sVersion, sOutput, sDescription, sTimestamp)
	if sID == nil or sID == "" then
		return false
	else
		if sAccuracy == nil then
			sAccuracy = 80
		elseif sAccuracy < 0 then
			sAccuracy = 0
		elseif sAccuracy > 100 then
			sAccuracy = 100
		end

		if sTesttype == nil then
			sTesttype = "Scanning"
		end

		if sTestsource == nil then
			sTestsource = "Application Fingerprint"
		end

		if sVersion == nil then
			sVersion = ""
		end

		if sOutput == nil then
			sOutput = ""
		end

		if sTimestamp == nil then
			sTimestamp = os.time()
		end

		return "sID{" .. sID .. "},\nsAccuracy{" .. sAccuracy .. "},\nsTesttype{" .. sTesttype .. "},\nsTestsource{" .. sTestsource .. "},\nsVersion{" .. sVersion .. "},\nsOutput{" .. sOutput .. "},\nsDescription{" .. sDescription .. "},\nsTimestamp{" .. sTimestamp .. "};"
	end
end
