author = "Marc Ruef"
license = "(c) 2010 by scip AG"
version = "1.0-hd10"
categories = {"default", "safe", "scip"}

require("scipreporting_hashdays")

description = [[ This script announces a successful identification of an http web server ]]

portrule = function(host, port)
	if port.protocol == "tcp" and port.service == "http" and port.version.product ~= nil then
		sAccuracy	= SCIP_DEFAULT_APPFINGERPRINT_ACCURACY
		sTesttype	= "Exploiting"
		sTestsource	= "Application Fingerprinting"
		sDescription	= "The web server software can be identified with http fingerprinting techniques. This makes it possible to initiate software-oriented attacks against the web server implementation."
		return true
	else
		return false
	end
end

action = function(host, port)
	return scipreport(4, sAccuracy, sTesttype, sTestsource, version, port.version.product .. " " .. port.version.version, sDescription)
end
