author = "Marc Ruef"
license = "(c) 2010 by scip AG"
version = "1.0-hd10"
categories = {"default", "safe", "scip"}

require("scipreporting_hashdays")
require("http")

description = [[ This script is identifying web servers that provide http services ]]

portrule = function(host, port)
	if port.protocol == "tcp" and (port.service == "http" or port.service == "ssl/http") then
		sAccuracy	= SCIP_DEFAULT_APPMAPPING_ACCURACY
		sTesttype	= "Exploiting"
		sTestsource	= "Application Mapping"
		return true
	elseif port.protocol == "tcp" and (port.number == 80 or port.number == 81 or port.number == 443 or port.number == 8443) then
		sAccuracy	= SCIP_DEFAULT_PORTSCAN_ACCURACY
		sTesttype	= "Scanning"
		sTestsource	= "Portscan"
		return true
	else
		return false
	end
end

action = function(host, port)
	local response = http.get(host, port, "/")

	if response.rawheader ~= nil then
		sOutput = "Header:\n\n" .. stdnse.format_output(true, response.rawheader)
	elseif response.body ~= nil then
		if response.body ~= "" then
			sOutput = "Body:\n\n" .. response.body
		else
			sOutput = ""
		end
	else
		sOutput = "It was not possible to fetch a resource with a common http get request. This might be a false positive."
	end

	sDescription = "The target service is a web server which is using the application protocol http to communicate. An attacker might approach this service to enumerate or compromise the target host."

	return scipreport(1, sAccuracy, sTesttype, sTestsource, version, sOutput, sDescription)
end
